package com.yaros.almacen.service;

import java.util.Collection;

import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yaros.almacen.dao.ProductDao;
import com.yaros.almacen.model.Product;

@Service
public class ProductService {

	@Autowired
	ProductDao productDao;
	
	@Autowired
	ProductQueryService queryService;
	
	public Collection <String> findAllNotes(){
		List<String> result = null;
		
		// @formatter:off
		result = productDao.findAll().stream().map(f -> f.getNotes())
				.flatMap(lista -> lista.stream())
				.distinct().sorted().collect(Collectors.toList());
		// @formatter:on
		return result;
	}
	
	public Collection <String> findAllManufacturers(){
		List<String> result = null;
		
		// @formatter:off
		result = productDao.findAll().stream().map(f -> f.getManufacturer())
				.distinct().sorted().collect(Collectors.toList());
		// @formatter:on
		return result;
	}
	
	public Collection<Product> findAll(){
		return productDao.findAll();
	}
	
	public Collection<Product> findByAnyNote(String... notes){
		return queryService.anyNote(notes).exec();
	}
	
	public Collection<Product> findByAnyManufacturer(String... manufacturer){
		return queryService.anyManufacturer(manufacturer).exec();
	}
	
	public Collection<Product> findByTitleContains(String name){
		return queryService.nameContains(name).exec();
	}
}
